using System;
using System.Collections;

namespace RateAllocation
{
	/// <summary>
	/// A call represents an call placed on the network
	/// </summary>
	public class Call
	{
		#region properties

		// the maximum length of the call
		public int Duration;
		// unique identifier
		public int CallID;
		// the starting node of the call
		public int SourceNodeID;
		// the final desitination of the call
		public int DestinationNodeID;
		// the current node the call is on
		public int CurrentNodeID;
		// an array of all visited node ids
		public ArrayList VisitedNodes= new ArrayList();
		// an array of final visted arrays after xxxx
		public  ArrayList FinalVisitedNodes= new ArrayList();
		// has the call finished
		public bool Finished=false;
		// has the call failed
		public bool HasFailed=false;
		// which direction is the ant agent moving in
		public eAntDirection AntDirection;
		// the new value of the node
		public double NewValue=-1;
		// the final count for visited nodes
		public int finalVisitedNodeCount=0;
		// total wait time for the call
		public int waitTime=0;
		// if the call was successful
		public bool Successful=false;


		// create a new call with a source and destination node
		public Call(int src, int dest)
		{
			this.CallID = Global.CallID;
			this.SourceNodeID = src;
			this.DestinationNodeID = dest;
			this.CurrentNodeID = src;
			this.VisitedNodes.Add(this.SourceNodeID);
			this.Duration=Global.CallDuration;
		}

		#endregion

		
		public void TerminateCall()
		{
			Node n;

	
			for(int i=0;i<Global.Nodes.Length;i++)
			{
			
				n = Global.Nodes[i];

			
				for(int j=0;j<n.CallIDS.Count;j++)
				{
				
					if(((int)n.CallIDS[j])==this.CallID)
					{
					
						n.CallIDS.RemoveAt(j);
					
						j=0;
					}
				}
			}
		}

		
		public void LoopRemoval()
		{
			int id1; 
			int id2;

		
			for(int i=0;i<VisitedNodes.Count;i++)
			{
				id1 = (int)VisitedNodes[i];

				for(int j=i+1;j<VisitedNodes.Count-1;j++)
				{
					id2 = (int)VisitedNodes[j];

				
					if(id1==id2)
					{
						
						ArrayList tArray = new ArrayList();

						for(int k=0;k<VisitedNodes.Count-1;k++)
						{
							
							tArray.Add(VisitedNodes[k]);
						}

						VisitedNodes = tArray;

					
						i=0;
					}
				}
			}
		}

	
		public int ConnectNextNode()
		{
			Node n = Global.Nodes[this.CurrentNodeID];

		
			for(int i=0;i<n.Connections.Length;i++)
			{
	
				if(n.Connections[i]==this.DestinationNodeID)
					return n.Connections[i];
			}

			
			for(int i=0;i<n.PheromoneTable.Length;i++)
			{
                if(this.DestinationNodeID==n.PheromoneTable[i].NodeID)
				{
					PheromoneTable p = n.PheromoneTable[i];
					
					return p.ProbablePath(VisitedNodes);
				}
			}

			
			return -1;
		}
	}
}