using System;
using System.Collections;

namespace RateAllocation
{
	/// <summary>
	///
	/// </summary>
	public class PheromoneTable
	{
		
		public TableEntry[] tableEntry;
		
		public int NodeID;

		
		public int ProbablePath(ArrayList VisitedNodes)
		{
			
			Random r = new Random(Global.Seed);

			double val=0;
			double count = 0;
			double Lastcount = -1;
	
			ArrayList tempTEVector=new ArrayList();

			
			for(int i=0;i<tableEntry.Length;i++)
			{
				
				bool v=false;

				
				for(int j=0;j<VisitedNodes.Count;j++)
				{
					
					if(tableEntry[i].NodeID==(int)VisitedNodes[j])
						v=true;
				}
				
				
				if(!v) 
				{
					
					Node n = Global.Nodes[tableEntry[i].NodeID];

					
					if(!n.FullCapacity)
					{
						
						tempTEVector.Add(tableEntry[i]);
					}
				}
			}
			
			
			if(tempTEVector.Count==0)
			{
		
				for(int i=0;i<tableEntry.Length;i++)
					tempTEVector.Add(tableEntry[i]);
			}

			
			for(int i=0;i<tempTEVector.Count;i++)
				val+= ((TableEntry)tempTEVector[i]).Probablilty;

		
			val = r.NextDouble()*val;

			
			for(int i=0;i<tempTEVector.Count;i++)
			{
				
				count += ((TableEntry)tempTEVector[i]).Probablilty;

			
				if(val>Lastcount && val < count)
					return ((TableEntry)tempTEVector[i]).NodeID;

				
				Lastcount=count;
			}

		
			return -1;
		}

		
		public void UpdateProbabilities(double newVal, int EntryTableNodeID)
		{
			TableEntry t;
			double total=0;

		
			for(int j=0;j<tableEntry.Length;j++)
			{
				t = tableEntry[j];

				
				total += t.Probablilty;
				
			
				if(EntryTableNodeID==t.NodeID)
				{
					
					total += newVal;
					t = tableEntry[j];
					
					t.Probablilty += newVal;
				}
			}

		
			double ratio = 100/total;

		
			for(int j=0;j<tableEntry.Length;j++)
			{
				tableEntry[j].Probablilty *= ratio;
			}

			
		}

	
		public PheromoneTable(Node n, int[] conns)
		{
			this.NodeID = n.ID;
		
			
			this.tableEntry = new TableEntry[conns.Length];

			for(int i=0;i<conns.Length;i++)
				tableEntry[i] = new TableEntry(conns[i]);

			
			for(int i=0;i<conns.Length;i++)
				tableEntry[i].Probablilty = (100 / (double)conns.Length);
		}
	}

	
	public class TableEntry
	{
		
		public int NodeID;
	
		public double Probablilty;

		
		public TableEntry(int nodeID)
		{
			this.NodeID = nodeID;
		}
	}
}
